#ifndef __cmt_tag_h__
#define __cmt_tag_h__

#include "cmt_parser.h"
#include "cmt_system.h"

class Tag
{
public:
  typedef cmt_vector<Tag> TagVector;
  typedef cmt_vector<Tag*> TagPtrVector;

  static void action (const CmtSystem::cmt_string_vector& words);
  static Tag* find (const cmt_string& name);
  static Tag* add (const cmt_string& name, int priority);
  static int tag_number ();
  static Tag* tag (int index);
  static void unmark_all ();
  static void clear_all ();
  static TagVector& all_tags ();
  static TagPtrVector& tags ();

public:
  Tag ();
  ~Tag ();
  void clear ();
  void add_tag_ref (Tag* ref);
  void unmark ();
  void mark ();

  cmt_string name;
  TagPtrVector tag_refs;
  int priority;
  int selected;
};

#endif
